local LUI, T, E, L, V, P, G = unpack(select(2, ...))
if LUI:CheckDB("db", "modules", "quest", "questAutomation", "enable") then return end
local LQAU = E:NewModule("LuiQuestAutomation", "AceEvent-3.0")

local function CreateAutoQuestButton()
    if QuestFrameAutomationBtn then return end
    local accept = T.CreateFrame("CheckButton", "QuestFrameAutomationBtn", ObjectiveTrackerFrame.HeaderMenu, "UICheckButtonTemplate")
    accept:Size(24, 24)
    accept.text:FontTemplate(nil, nil, "OUTLINE")
    accept.text:SetText(L["QuestFrameAutomationBtn"])
    accept:Point("LEFT", ObjectiveTrackerFrame.HeaderMenu, "LEFT", (E.db.lui.modules.quest.questAnnouncment["enable"] and E.db.lui.modules.quest.questAnnouncment["frameBtn"]) and -140 or -80, -9)
    if E.db.lui.modules.quest.questAutomation["ElvUISkins"] then
        E.Skins:HandleCheckBox(accept)
    end
    accept:SetScript("OnClick", function(self)
        E.db.lui.modules.quest.questAutomation["syncBtn"] = not E.db.lui.modules.quest.questAutomation["syncBtn"]
        LQAU:CheckSyncBtn()
    end)
    accept:SetChecked(E.db.lui.modules.quest.questAutomation["syncBtn"])
    T.hooksecurefunc("ObjectiveTracker_Update", function()
        if ObjectiveTrackerFrame.collapsed then
            if accept:IsShown() then
                accept:Hide()
            end
        else
            if not accept:IsShown() then
                accept:Show()
            end
		end
    end)
    T.hooksecurefunc("ObjectiveTracker_Collapse", function()
        if ObjectiveTrackerFrame.collapsed then
            if accept:IsShown() then
                accept:Hide()
            end
		end
    end)
    T.hooksecurefunc("ObjectiveTracker_Expand", function()
        if ObjectiveTrackerFrame.collapsed then
            if not accept:IsShown() then
                accept:Show()
            end
		end
    end)
end

function LQAU:CheckConfigs()
    if T.UnitInRaid("player") and ( not E.db.lui.modules.quest.questAutomation["inRaid"] ) then return end
	if T.IsModifierKeyDown() then
		if ( E.db.lui.modules.quest.questAutomation["disableKey"] == 1 ) and T.IsAltKeyDown() then return
        elseif ( E.db.lui.modules.quest.questAutomation["disableKey"] == 2 ) and T.IsControlKeyDown() then return
        elseif ( E.db.lui.modules.quest.questAutomation["disableKey"] == 3 ) and T.IsShiftKeyDown() then return end
    end
	if (T.UnitGUID("target") and T.string_find(T.UnitGUID("target"), "(.*)-(.*)")) then
		local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = T.string_split("-",T.UnitGUID("target"))
		if (npc_id and ((T.tonumber(npc_id) == 141584) or (T.tonumber(npc_id) == 142063))
			or (T.tonumber(npc_id) == 111243)
			or ((T.tonumber(npc_id) == 87391) or (T.tonumber(npc_id) == 88570) or (T.tonumber(npc_id) == 96130))
			or ((T.tonumber(npc_id) == 64029) or (T.tonumber(npc_id) == 63996))
			or (T.tonumber(npc_id) == 73305))
		then
			return
		end
	end
    return true
end

function LQAU:CheckQuestData()
    if E.db.lui.modules.quest.questAutomation["dailiesOnly"] then
        return
    end
    if T.QuestFlagsPVP() and ( not E.db.lui.modules.quest.questAutomation["acceptPVP"] ) then
        return
    end
    return true
end

function LQAU:QUEST_GREETING()
    if LQAU:CheckConfigs() and E.db.lui.modules.quest.questAutomation["skipGreetings"] then
        local numact,numava = T.GetNumActiveQuests(), T.GetNumAvailableQuests()
        if numact+numava == 0 then return end

        if numava > 0 then
            T.SelectAvailableQuest(1)
        end
        if numact > 0 then
            T.SelectActiveQuest(1)
        end
    end
end

function LQAU:GOSSIP_SHOW()
    if LQAU:CheckConfigs() and E.db.lui.modules.quest.questAutomation["skipGreetings"] then
        if T.GetGossipAvailableQuests() then
            T.SelectGossipAvailableQuest(1)
        elseif GetGossipActiveQuests() then
            T.SelectGossipActiveQuest(1)
        end
    end
end

function LQAU:QUEST_DETAIL()
    if LQAU:CheckConfigs() and LQAU:CheckQuestData() and E.db.lui.modules.quest.questAutomation["autoAccept"] then
        T.AcceptQuest()
    end
end

function LQAU:QUEST_ACCEPT_CONFIRM()
    if LQAU:CheckConfigs() and E.db.lui.modules.quest.questAutomation["acceptEscort"] then
        T.ConfirmAcceptQuest()
    end
end

function LQAU:QUEST_PROGRESS()
    if LQAU:CheckConfigs() and E.db.lui.modules.quest.questAutomation["autoComplete"] then
        T.CompleteQuest()
    end
end

local dbg = 0
function LQAU:SelectQuestReward(index)
	local frame = QuestInfoFrame.rewardsFrame
	if dbg == 1 then
		LUI:Print("index: "..index)
	end
	local button = QuestInfo_GetRewardButton(frame, index)
	if (button.type == "choice") then
		QuestInfoItemHighlight:ClearAllPoints()
		QuestInfoItemHighlight:SetOutside(button.Icon)

		if E.private.skins.blizzard.enable ~= true or E.private.skins.blizzard.quest ~= true then
			QuestInfoItemHighlight:SetPoint("TOPLEFT", button, "TOPLEFT", -8, 7)
		else
			button.Name:SetTextColor(1, 1, 0)
		end
		QuestInfoItemHighlight:Show()
		QuestInfoFrame.itemChoice = button:GetID()
	end
end

function LQAU:QUEST_COMPLETE()
    if LQAU:CheckConfigs() and E.db.lui.modules.quest.questAutomation["autoComplete"] then
        if T.GetNumQuestChoices() == 0 then
            T.GetQuestReward(QuestFrameRewardPanel.itemChoice)
        elseif T.GetNumQuestChoices() == 1 and QuestFrameRewardPanel.itemChoice == nil then
            T.GetQuestReward(1)
        end
    end
	if E.db.lui.modules.quest.questAutomation["autoReward"] then
		local choice, highest = 1, 0
		local num = T.GetNumQuestChoices()
		if dbg == 1 then
			LUI:Print("T.GetNumQuestChoices"..num)
		end
		if num <= 0 then return end
		for index = 1, num do
			local link = T.GetQuestItemLink("choice", index)
			if link then
				local price = select(11, T.GetItemInfo(link))
				if price and price > highest then
					highest = price
					choice = index
				end
			end
		end
		if dbg == 1 then
			LUI:Print("Choice: "..choice)
		end
		LQAU:SelectQuestReward(choice)
	end
end

function LQAU:CheckSyncBtn()
    if E.db.lui.modules.quest.questAutomation["syncBtn"] then
        self:RegisterEvent("QUEST_GREETING")
        self:RegisterEvent("GOSSIP_SHOW")
        self:RegisterEvent("QUEST_DETAIL")
        self:RegisterEvent("QUEST_ACCEPT_CONFIRM")
        self:RegisterEvent("QUEST_PROGRESS")
        self:RegisterEvent("QUEST_COMPLETE")
    else
        self:UnregisterEvent("QUEST_GREETING")
        self:UnregisterEvent("GOSSIP_SHOW")
        self:UnregisterEvent("QUEST_DETAIL")
        self:UnregisterEvent("QUEST_ACCEPT_CONFIRM")
        self:UnregisterEvent("QUEST_PROGRESS")
        self:UnregisterEvent("QUEST_COMPLETE")
    end
end

function LQAU:Initialize()
    if E.db.lui.modules.quest.questAutomation["frameBtn"] then
        CreateAutoQuestButton()
    end
    self:CheckConfigs()
    self:CheckQuestData()
    self:CheckSyncBtn()
end

local function InitializeCallback()
    if not E.db.lui.modules.quest.questAutomation["enable"] then return end
	LQAU:Initialize()
end

E:RegisterModule(LQAU:GetName(), InitializeCallback)
